<?

/*   db_func.inc for UdmSearch 3.0.0
 *   (C) 1999,2000 by Sergey Kartashoff aka gluke,
 *                    UdmSearch Developers Team
 *   features: mysql and oracle support.
 *             mysql  works only in single-dict table
 *             oracle works both multi- and single-dict table mode 
 */

// -----------------------------------------------
// initdb()
// -----------------------------------------------
function initdb(){
   global $dbhost,$dbuser,$dbpass,$dbname,$dbport,$dbtype;
   global $dbconn;

   switch($dbtype) {
      case 'mysql':
         if ($dbport == '') {
           if (!mysql_pconnect($dbhost,$dbuser,$dbpass))
              print_error_local("Cannot connect to mysql host $dbhost as user $dbuser");
         } else {
           if (!mysql_pconnect("$dbhost:$dbport",$dbuser,$dbpass))
              print_error_local("Cannot connect to host $dbhost:$dbport as user $dbuser");
         }
         
         if (! mysql_select_db($dbname))
            print_error_local("DB $dbname select error");

         break;
      case 'oracle':
         if (! $dbconn=OCIPLogon($dbuser,$dbpass,$dbname)) 
            print_error_local("Cannot connect to oracle db $dbname as user $dbuser");

         break;
      default:
         print_error_local("Unknown DBType: $dbtype");
   }
}

// -----------------------------------------------
// query($query)
// -----------------------------------------------
function query($query) {
   global $dbtype;
   global $dbconn;

   switch($dbtype) {
      case 'mysql':
         $res=mysql_query($query);
         break;
      case 'oracle':
         if (! $pres=OCIPArse($dbconn,$query)) return $res;
         $res=OCIExecute($pres);
         if ($res)  return ($pres);
         break;
      default:
         print_error_local("Unknown DBType: $dbtype");
   }

   return($res);
}

// -----------------------------------------------
// fetch_row($res)
// -----------------------------------------------
function fetch_row($res) {
   global $dbtype;

   switch($dbtype) {
      case 'mysql':
         $row=mysql_fetch_row($res);
         break;
      case 'oracle':
         $result=OCIFetchInto($res,&$row,OCI_NUM+OCI_RETURN_NULLS );
         if (! $result) $row=array();
         break;
      default:
         print_error_local("Unknown DBType: $dbtype");
   }

   return($row);
}

// -----------------------------------------------
// db_numrows($res)
// -----------------------------------------------
function db_numrows($res) {
   global $dbtype;

   switch($dbtype) {
      case 'mysql':
         $rows=mysql_numrows($res);
         break;
      default:
         print_error_local("Unknown DBType: $dbtype");
   }

   return($rows);
}

// -----------------------------------------------
// db_data_seek($res,$from)
// -----------------------------------------------
function db_data_seek($res,$from) {
   global $dbtype;

   switch($dbtype) {
      case 'mysql':
         $dataseek=mysql_data_seek($res,$from);
         break;
      case 'oracle':
         $dataseek=1;
         for ($i=0; $i<$from; $i++) {
            $row=fetch_row($res);
            if (! $row) {
               $dataseek=0;
               break;
            }
         }
         break;
      default:
         print_error_local("Unknown DBType: $dbtype");
   }

   return($dataseek);
}

// -----------------------------------------------
// free_result($res)
// -----------------------------------------------
function free_result($res) {
   global $dbtype;

   switch($dbtype) {
      case 'mysql':
         mysql_free_result($res);
         break;
      case 'oracle':
         OCIFreeStatement($res);
         break;
      default:
         print_error_local("Unknown DBType: $dbtype");
   }
}

// -----------------------------------------------
// db_error()
// -----------------------------------------------
function db_error() {
   global $dbtype;

   switch($dbtype) {
      case 'mysql':
         $error=mysql_error();
         break;
      case 'oracle':
         $error=OCIError();
         break;
      default:
         print_error_local("Unknown DBType: $dbtype");
   }

   return $error;
}

?>
